Subject: [Iptel] rfc4904: tgrp case sensitivity

From: Brett Tate <[email-masked]>
Date: Fri, 9 Aug 2013 13:48:21 +0000

Hi,

Since I didn't much feedback on sip-implementors email list (thanks Hadriel), I thought that I'd try iptel.

I find RFC 4904, RFC 3966, and RFC 3261 somewhat ambiguous concerning tgrp case sensitivity.  I understand the rules from uri perspective: tgrp case-insensitive within telephone-uri, and tgrp case-sensitive within sip-uri.

RFC 4904 section 5:

"For equivalency purposes, two URIs containing trunk group parameters
 are equivalent according to the base comparison rules of the URIs.
 The base comparison rules of a tel URI are specified in Section 4 of
 [4], and the base comparison rules of a sip URI are specified in
 Section 19.1.4 of [3]."

RFC 3966 section 4:

"o  URI comparisons are case-insensitive.

 All parameter names and values SHOULD use lower-case characters, as
 tel URIs may be used within contexts where comparisons are case
 sensitive."

RFC 3261 section 19.1.6:

"In general, equivalent "tel" URLs converted to SIP or SIPS URIs in
 this fashion may not produce equivalent SIP or SIPS URIs.  The
 userinfo of SIP and SIPS URIs are compared as a case-sensitive
 string.  Variance in case-insensitive portions of tel URLs and
 reordering of tel URL parameters does not affect tel URL equivalence,
 but does affect the equivalence of SIP URIs formed from them."

"To mitigate this problem, elements constructing telephone-subscriber
 fields to place in the userinfo part of a SIP or SIPS URI SHOULD fold
 any case-insensitive portion of telephone-subscriber to lower case,
 and order the telephone-subscriber parameters lexically by parameter
 name, excepting isdn-subaddress and post-dial, which occur first and
 in that order.  (All components of a tel URL except for future-
 extension parameters are defined to be compared case-insensitive.)"

However once decoded/extracted out of the sip-uri or telephone-uri, is the tgrp value case sensitive?  Since tgrp is case-insensitive within telephone-uri's telephone-subscriber (also used by sip-uri), I assume that the tgrp value is case-insensitive since it would be strange for the tgrp value to be context sensitive based upon if sent within sip-uri or telephone-uri.  However, I also would not be surprised if someone said that nobody knows except for the owner of the trunk-context.

RFC 4904 section 5 examples intentionally or unintentionally ignored RFC 3966 and RFC 3261 recommendation to use lower case.

Thanks,
Brett

This email is intended solely for the person or entity to which it is addressed and may contain confidential and/or privileged information. If you are not the intended recipient and have received this email in error, please notify BroadSoft, Inc. immediately by replying to this message, and destroy all copies of this message, along with any attachment, prior to reading, distributing or copying it.